package edu.berkeley.sbp;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;
import java.lang.ref.*;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.util.*;

/** a stream of tokens to be parsed */
public interface Input<Token> {

    /** returns the token just beyond the current location and advances beyond it */
    public Token    next(int numstates, int resets, int waits) throws IOException;

    /** returns the location the input stream is currently at */
    public Location getLocation();

    /** a location *between tokens* in the input stream */
    public static interface Location {
        public String toString();
    }
}


